function discs=LMfuncTH(unks)

%  Given theta and SDF, finds the corresponding sticky wage
%  Paste 'results' matrix into HDHU results.xlsx, tab 'StateVals'

global eta mu psi N kappa stateCal z ifTrack Track W
global theta g X beta omega M pi q U C m WE WK r

uLoc=1;
U=unks(uLoc:uLoc+N-1);
uLoc=uLoc+N;
C=unks(uLoc:uLoc+N-1);
uLoc=uLoc+N;
W=unks(uLoc:uLoc+N-1);

%  There are 3N unknowns

%  Form omega, matrix of state prices

M=zeros(N);
for s=1:N
    for sprime=1:N
        M(s,sprime)=m(sprime)/m(s);
    end
end
omega=beta*pi.*M.*g;

%  Calculate X

Mat=eye(N)-(1-psi)*omega;
Inv=Mat^(-1);
X=Inv*ones(N,1);

%  Form discrepancies

dLoc=1;
discs=zeros(3*N,1);
for s=1:N
    discs(dLoc)=z-U(s);  %  U equation
    f=mu*theta(s)^eta;  %  job-finding rate
    for sprime=1:N
        discs(dLoc)=discs(dLoc)+omega(s,sprime)*(f*(W(sprime)+C(sprime))+(1-f)*U(sprime));
    end
    dLoc=dLoc+1;
    
    discs(dLoc)=-C(s);  %  C equation
    for sprime=1:N
        discs(dLoc)=discs(dLoc)+ omega(s,sprime)*(psi*U(sprime)+(1-psi)*C(sprime));
    end
    dLoc=dLoc+1;
    
    q(s,1)=f/theta(s);  %  vacancy-filling rate
    discs(dLoc)=-q(s)*(X(s)-W(s))+kappa;  %  zero-profit condition (theta)
    dLoc=dLoc+1;
end
%  There are 3N discrepancies

if ifTrack
    Track=[Track,theta,X,WE,WK,discs];
end