function discs=LMfuncZ(unks)

%  Calculates discrepancies in the credible-bargaining model.
%  SDF is a driving force; solves for theta, delta, gamma


global eta mu gamma psis delta N kappa z ifTrack Track W
global theta g X beta omega M pi q U C m WE WK  thetaActual

% unks=real(unks);
uLoc=1;
U=unks(uLoc:uLoc+N-1);
uLoc=uLoc+N;
C=unks(uLoc:uLoc+N-1);
uLoc=uLoc+N;
theta=unks(uLoc:uLoc+N-1);
uLoc=uLoc+N;
WE=unks(uLoc:uLoc+N-1);
uLoc=uLoc+N;
WK=unks(uLoc:uLoc+N-1);
uLoc=uLoc+N;
delta=unks(uLoc);
uLoc=uLoc+1;
gamma=unks(uLoc);

%  There are 5N+2 unknowns

%  Form omega, matrix of state prices

M=zeros(N);
for s=1:N
    for sprime=1:N
        M(s,sprime)=m(sprime)/m(s);
    end
end
omega=beta*pi.*M.*g;

%  Calculate X and r

Mat=eye(N);
for s=1:N
    for sprime=1:N
        Mat(s,sprime)=Mat(s,sprime)-(1-psis(s))*omega(s,sprime);
    end
end
Inv=Mat^(-1);
X=Inv*ones(N,1);

%  Form discrepancies

dLoc=1;
discs=zeros(4*N,1);
W=0.5*(WE+WK);
for s=1:N
    discs(dLoc)=z-U(s);  %  U equation
    f=mu*theta(s)^eta;  %  job-finding rate
    for sprime=1:N
        discs(dLoc)=discs(dLoc)+omega(s,sprime)*(f*(W(sprime)+C(sprime))+(1-f)*U(sprime)); 
    end
    dLoc=dLoc+1;
    
    discs(dLoc)=-C(s);  %  C equation
    for sprime=1:N
    discs(dLoc)=discs(dLoc)+ omega(s,sprime)*(psis(s)*U(sprime)+(1-psis(s))*C(sprime));  
    end
    dLoc=dLoc+1;
    
    q(s,1)=f/theta(s);  %  vacancy-filling rate
    discs(dLoc)=-q(s)*(X(s)-W(s))+kappa;  %  zero-profit condition (theta)
    dLoc=dLoc+1;
    
    discs(dLoc)=delta*U(s)+(1-delta)*z-WE(s)-C(s);  %  WE equation
    for sprime=1:N
        discs(dLoc)=discs(dLoc)+(1-delta)*omega(s,sprime)*(WK(sprime)+C(sprime)); 
    end
    dLoc=dLoc+1;
    
    discs(dLoc)=-(1-delta)*gamma-X(s)+WK(s);  %  WK  equation
    for sprime=1:N
        discs(dLoc)=discs(dLoc)+(1-delta)*omega(s,sprime)*(X(sprime)-WE(sprime)) ;  
    end
    dLoc=dLoc+1;
end

discs(dLoc)=theta(3)-thetaActual(3);  %  match the central tendency
dLoc=dLoc+1;
discs(dLoc)=theta(5)-theta(1)-(thetaActual(5)-thetaActual(1));  %  match the overall slope 

%  There are 5N+2 discrepancies

%discs=real(discs);

if ifTrack
    Track=[Track,theta,X,WE,WK,discs];
end