%  Given theta, beta, m, and g,
%  Calculates theta given  for credible bargaining
%  Uses beta and m already in memory, from SM.m
%  Paste 'results' in HDHU.xlsx, tab 'IRFs'

global z

clc

options=optimset('Display','iter','MaxFunEvals',5000,'MaxIter',5000,'TolFun',.000000001,'TolX',.000000001);

theta=thetaActual;

%  Starting values

UStart=30*ones(N,1);
CStart=15*ones(N,1);
WEStart=16*ones(N,1);
WKStart=17*ones(N,1);

%  Now solve

outputLMTH=[];
deltaStart=0;
gammaStart=0.55;


unks=[UStart;CStart;WEStart;WKStart;deltaStart;gammaStart];
[unksNew,fval]=fsolve(@LMfuncNoZ,unks,options);
Fit=std(fval);
outputNoZ=[delta,gamma,Fit];

%  Discount, r

rStart=[0.3;0.2;0.15;0.05;0];
r=fsolve(@IRR,rStart,options);

%  Expected productivity growth

for s=1:N
    exg(s,1)=pi(s,:)*g(s,:)';
end

resultsNoZ=[U C m WE WK,W,X,theta,100*r,exg,X-W,[beta;delta;gamma;z;0],omega,r,X-W-kappa*sqrt(theta)/mu];

%  Now use that solution as starting values to solve for theta, delta, and  gamma

unks=[unksNew(1:2*N);thetaActual;unksNew(2*N+1:4*N+2)];
checkZ=LMfuncZ(unks);
[unksNew,fval]=fsolve(@LMfuncZ,unks,options);
Fit=std(fval);
outputZ=[delta,gamma,Fit];
resultsCB=[U C m WE WK,W,X,theta,100*r,exg,X-W,[beta;delta;gamma;z;kappa],omega,r];
