%  Calculates variables given theta, beta, m, and g
%  Uses beta and m already in memory, from SM.m

clc
options=optimset('Display','none','MaxFunEvals',5000,'MaxIter',5000,'TolFun',.000000001,'TolX',.000000001);

%  Starting values

UStart=30*ones(N,1);
CStart=15*ones(N,1);
WStart=16*ones(N,1);

%  Solve for U, C, and W

outputLMTH=[];
theta=thetaActual;
unks=[UStart;CStart;WStart];
check=LMfuncTH(unks);

[unksNew,fval]=fsolve(@LMfuncTH,unks,options);
Fit=std(fval);
outputLMTH=[outputLMTH;[wBar,gamma,z,kappa,theta(3),theta(5)-theta(1),Fit]];

%  Discount, r

rStart=[0.3;0.2;0.15;0.05;0];
r=fsolve(@IRR,rStart,options);

%  Expected productivity growth

for s=1:N
    exg(s,1)=pi(s,:)*g(s,:)';
end

resultsTH=[X U C m W,X,q,theta,100*r,exg,X-W,[beta;zeros(N-1,1)],omega,r];
