function discs=SMfunc(m)
%  returns discrepancies between the fitted and actual valuations of the
%  return matrix R for a trial value of m, which contains beta and
%  m(1)...m(N)
%  Returns are in productivity units and the discounter is omega in
%  productivity units
 
global pi R g

%  pi(s,sprime) is the transition matrix and R(s,sprime) is the matrix of
%  returns

beta=m(1);
mH=m;
mH(1)=1;  %  Normalization
N=numel(mH);
discs=zeros(N,1);
for s=1:N
    for sprime=1:N
        discs(s)=discs(s)+beta*pi(s,sprime)*g(s,sprime)*mH(sprime)*R(s,sprime)/mH(s);
    end
    discs(s)=discs(s)-1;
end